<template>
    <v-overlay v-model="statusOverlay" class="ma-10 pa-10 align-center justify-center">
        <v-card class="lg" width="">
            <v-card-text class="text-h2 text-center ma-10 pa-10">
                <!-- สถานะการ Login -->
                {{ statusLog }}
            </v-card-text>
        </v-card>
    </v-overlay>

    <v-card class="rounded-xl" image="https://i.ibb.co/QHSMnMb/workshop-login-bg.png">
        <!-- <span class="">PIPAD</span> -->
        <v-container cols="12" class="d-flex align-center" style="height:600px">
            <v-row>
                <v-col lg="1" class="hidden-sm-and-down">
                </v-col>
                <v-col class="rounded-xl fill-height"
                    style="background-color: rgba(245, 245, 245,0.3 );backdrop-filter: blur(20px);">
                    <v-card class="lg " variant="text">
                        <v-card-item>
                            <v-card-title class="text-lg-h1">LOGIN</v-card-title>
                            <v-card-subtitle class="text-wrap">welcome to your login to background management
                                system</v-card-subtitle>
                        </v-card-item>

                        <!-- สร้าง Form เพื่อเช็ค Rules ของ v-text ว่า return true หรือไม่ -->
                        <v-form v-model="formRules">

                            <!-- v-text สำหรับ email -->
                            <v-text-field variant="solo" v-model="loginEmail" name="loginEmail" label="Email"
                                placeholder="Please enter your Email" :rules="emailRules" />

                            <!-- v-text สำหรับ password -->
                            <v-text-field variant="solo" v-model="loginPassword" label="Password"
                                :append-inner-icon="visible ? 'mdi-eye-off' : 'mdi-eye'"
                                :type="visible ? 'text' : 'password'" placeholder="Please enter your password"
                                @click:append-inner="visible = !visible" :rules="passwordRules" counter="6" />
                        </v-form>

                        <v-card-actions class="">
                            <!-- ทำให้ปุ่ม Disabled ถ้า rules ข้างใน form ยังไม่เป็น true -->
                            <v-btn :disabled="!formRules" variant="flat" @click="loginMelive()" color="info">LOGIN</v-btn>
                        </v-card-actions>
                    </v-card>
                </v-col>

                <v-col lg="7" class="hidden-sm-and-down">
                </v-col>
            </v-row>
        </v-container>
    </v-card>
</template>

<script>
definePageMeta({
    middleware: "pipad-auth"
})
const config = useRuntimeConfig();
const URL_Auth = config.public.URL_Auth;
export default {
    data: () => ({
        formRules: false,
        visible: false, //ตัวแปรสำหรับเปิดปิด textbox รหัสผ่าน
        loginEmail: '', //ตัวแปรเก็บ Email ใน Textbox
        loginPassword: '', //ตัวแปรเก็บ Password ใน Textbox
        statusOverlay: false, //หน้าต่างแสดงผลการ Login 
        statusLog: '', //ตัวแปรเก็บสถานะผลลัพท์การ Login
        // ตั้ง rules ให้ password ต้องมากกว่าเท่ากับ 6 ตัวอักษร
        passwordRules: [
            value => {
                if (value?.length >= 6) return true
                return 'Password must be at least 6 characters.'
            },
        ],
        // ตั้ง rules ให้ email ต้องมีลักษณะเป็น test@test.test
        emailRules: [
            value => {
                if (/^[^\s@]+@[^\s@]+\.[^\s@]+$/.test(value)) return true
                return 'Email pattern not valid.'
            },
        ],
    }),
    methods: {
        //method สำหรับ login
        async loginMelive() {
            try {
                //เรียก API login
                const response = await fetch(`${URL_Auth}/api/login`, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    //ส่งค่าตัวแปร loginEmail และ LoginPassword ที่ดึงค่ามาจาก text-box
                    body: JSON.stringify({
                        'username': this.loginEmail,
                        'password': this.loginPassword,
                    }),
                });
                //รับค่า response กลับมาลงใน result
                const result = await response.json();
                if (result.status === 'ok') {
                    console.info(result.message)
                    this.statusLog = result.message + ' : ' + result.user.username;
                    console.info('LOGIN LOG : ' + this.statusLog);
                    this.statusOverlay = !this.statusOverlay;
                    console.log(result.user);
                    // ล้างค่าในตัวแปร
                    this.loginEmail = '';
                    this.loginPassword = '';
                    // เก็บค่า user และ accessToken ไว้ใน localStorage ที่มี key ชื่อ userData accessToken ตามลำดับ
                    window.localStorage.setItem('userData', JSON.stringify(result.user));
                    window.localStorage.setItem('accessToken', result.accessToken);
                    this.$router.go(0); // รีโหลดหน้าเพจ
                }
                // หาก error จะ log error ออกมาและแสดงบน console และบนหน้าจอ
                if (result.status === 'error') {
                    console.error(result.message)
                    this.statusLog = result.message;
                    console.info('LOGIN LOG : ' + result.message);
                    this.statusOverlay = !this.statusOverlay;
                }

            } catch (error) {
                console.error(error)
            }
        }
    },
}
</script>